<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from transform.texi on 28 April 1999 -->

<TITLE>The TRANSFORM Library - Loop Transformations</TITLE>
<link href="transform_3.html" rel=Next>
<link href="transform_1.html" rel=Previous>
<link href="transform_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="transform_1.html">first</A>, <A HREF="transform_1.html">previous</A>, <A HREF="transform_3.html">next</A>, <A HREF="transform_8.html">last</A> section, <A HREF="transform_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC2" HREF="transform_toc.html#TOC2">Loop Transformations</A></H1>

<P>
Both unimodular and tiling loop transformations are part of the 
class <CODE>loop_transform</CODE>.
The <CODE>loop_transform</CODE> class contains an array of <CODE>tree_for</CODE> nodes.
The <CODE>tree_fors</CODE> must be nested within one another in the SUIF code,
and are ordered from outermost to innermost.  
For example, given the code:

</P>

<PRE>
for (i = 0; i &#60; N; i++) {
        ...
    for (j = 0; j &#60; N; j++) {
            ...
        for (k = 0; k &#60; N; k++) {
                    ...
        }
    }
}
</PRE>

<P>
The loops array would contain pointers to the <CODE>tree_for</CODE> nodes for loops 
in the order <CODE>i</CODE>, <CODE>j</CODE> and then <CODE>k</CODE>.

</P>
<P>
In most cases the loops need not be perfectly nested.  
There can be simple instructions between loops, but non-nested loops
are not allowed.
For example, the loops in the following code are not nested within one
another, and thus <EM>cannot</EM> be transformed:

</P>

<PRE>
for (i = 0; i &#60; N; i++) {
        ...
    for (j = 0; j &#60; N; j++) {
            ...
    }
    for (k = 0; k &#60; N; k++) {
            ...
    }
}
</PRE>

<P>
In order to be able to calculate the bounds after transformation, the
transform library requires that the bounds of the loops define a polytope
(a finite convex polyhedron) in the iteration space.  
Each lower and upper bound expression must be an affine function of any
outer loop indices plus a constant.  
The function <CODE>bounds_ok</CODE> checks the upper and lower bound of a
<CODE>tree_for</CODE> to make sure the bounds are legal.
The constructor for the <CODE>loop_transform</CODE> class normalizes the 
bounds of the loops to have a unit step size and so that the test of
the <CODE>tree_for</CODE> is less-than-or-equal.

</P>
<P>
The <CODE>loop_transform</CODE> class may also contain an array of booleans that
specifies whether the corresponding <CODE>tree_for</CODE> in the loops array
is a doall loop.

</P>

<UL>
<LI><A HREF="transform_3.html#SEC3">Unimodular Transforms</A>: How to generate unimodular loop transformations.
<LI><A HREF="transform_4.html#SEC4">Tiling Transforms</A>: How to generate tiled code.
<LI><A HREF="transform_8.html#SEC8">Transformation Annotations</A>: The annotations generating by this library
</UL>

<P><HR><P>
<p>Go to the <A HREF="transform_1.html">first</A>, <A HREF="transform_1.html">previous</A>, <A HREF="transform_3.html">next</A>, <A HREF="transform_8.html">last</A> section, <A HREF="transform_toc.html">table of contents</A>.
</BODY>
</HTML>
